SystemOrganization addCategory: #'Keymapping-Core'!

!Morph methodsFor: '*Keymapping-Core' stamp: 'GuillermoPolito 5/31/2011 11:19'!
allowsKeymapping
	^ true! !

!Morph methodsFor: '*Keymapping-Core' stamp: 'GuillermoPolito 10/20/2011 17:44'!
attachKeymapCategory: aCategoryName
	self kmDispatcher attachCategory: aCategoryName.! !

!Morph methodsFor: '*Keymapping-Core' stamp: 'GuillermoPolito 10/20/2011 23:33'!
attachKeymapCategory: aCategoryName onProperty: aProperty
	self kmDispatcher attachCategory: aCategoryName onProperty: aProperty! !

!Morph methodsFor: '*Keymapping-Core' stamp: 'GuillermoPolito 10/20/2011 18:09'!
attachKeymapCategory: aCategoryName targetting: anObject
	self kmDispatcher attachCategory: aCategoryName targetting: anObject! !

!Morph methodsFor: '*Keymapping-Core' stamp: 'GuillermoPolito 3/14/2011 00:03'!
dispatchKeystrokeForEvent: evt 
	self kmDispatcher dispatchKeystroke: evt 
! !

!Morph methodsFor: '*Keymapping-Core-override' stamp: 'DouailleErwan 4/17/2012 14:43'!
handleKeystroke: anEvent 
	"System level event handling."

	anEvent wasHandled
		ifTrue: [^ self].
		
	self allowsKeymapping 
		ifTrue: [
			self dispatchKeystrokeForEvent: anEvent.
			anEvent wasHandled
				ifTrue: [^ self]].
			
	(self handlesKeyboard: anEvent)
		ifFalse: [^ self].
	anEvent wasHandled: true.
	self keyStroke: anEvent.
	^ self eventHandler ifNotNil: [:handler | handler keyStroke: anEvent fromMorph: self ].! !

!Morph methodsFor: '*Keymapping-Core' stamp: 'CamilloBruni 3/18/2011 23:05'!
kmDispatcher
	^ self valueOfProperty: #kmDispatcher ifAbsentPut: [KMDispatcher target: self]! !

!Morph methodsFor: '*Keymapping-Core' stamp: 'GuillermoPolito 9/12/2011 16:39'!
on: aShortcut do: anAction
	self kmDispatcher on: aShortcut asShortcut do: anAction! !

!TextMorph methodsFor: '*Keymapping-Core-override' stamp: 'GuillermoPolito 10/21/2011 09:15'!
handleKeystroke: anEvent 
	"System level event handling."
	| pasteUp |

	anEvent wasHandled
		ifTrue: [^ self].
	self allowsKeymapping
		ifTrue: [ self dispatchKeystrokeForEvent: anEvent ] .
	anEvent wasHandled
		ifTrue: [^ self].
	(self handlesKeyboard: anEvent)
		ifFalse: [^ self].
	anEvent keyCharacter = Character tab
		ifTrue: ["Allow passing through text morph inside pasteups"
			pasteUp := self pasteUpMorphHandlingTabAmongFields.
			(self wouldAcceptKeyboardFocusUponTab
					and: [(pasteUp) notNil])
				ifTrue: [^ pasteUp tabHitWithEvent: anEvent]].
	self keyStroke: anEvent.
	anEvent wasHandled: true.! !

!Integer methodsFor: '*Keymapping-Core' stamp: 'CamilloBruni 3/18/2011 23:16'!
asShortcut
	^ KMSingleKeyShortcut from: self asCharacter! !

!KeyboardEvent methodsFor: '*Keymapping-Core' stamp: 'GuillermoPolito 9/12/2011 17:14'!
altKeyPressed
	^self commandKeyPressed! !

!KeyboardEvent methodsFor: '*Keymapping-Core' stamp: 'GuillermoPolito 11/2/2011 22:32'!
asShortcut
	^ KMShortcut fromKeyboardEvent: self! !

!KeyboardEvent methodsFor: '*Keymapping-Core' stamp: 'DeboraFortini 11/1/2011 16:37'!
modifiedCharacter
    self flag: #hack.
    "Hack me.  When Ctrl is pressed, the key ascii value is not right and we have to do something ugly"
    ^(self controlKeyPressed and: [ (#(MacOSX Windows) includes: Smalltalk os current platformFamily) and: [ keyValue <= 26 ]])
        ifTrue: [ (self keyValue + $a asciiValue - 1) asCharacter ]    
        ifFalse: [ self keyCharacter ]! !

Object subclass: #KMCategory
	instanceVariableNames: 'name platforms'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Core'!

!KMCategory commentStamp: 'GuillermoPolito 12/14/2010 21:32' prior: 0!
I am a keymap category.  I represent a set of keymaps that can be attached to a morph, so morphs can share my keymaps.!

!KMCategory class methodsFor: 'instance creation' stamp: 'CamilloBruni 3/18/2011 23:11'!
named: aCategorySymbol
	^ (self new)
		name: aCategorySymbol;
		yourself! !

!KMCategory methodsFor: 'associating' stamp: 'GuillermoPolito 10/21/2011 01:16'!
addKeymapEntry: aKeymapEntry 
	aKeymapEntry hasName 
		ifTrue: [ self commonEntries at: aKeymapEntry name put: aKeymapEntry].! !

!KMCategory methodsFor: 'associating' stamp: 'GuillermoPolito 10/21/2011 00:39'!
addKeymapEntry: aKeymapEntry at: aPlatform
	aKeymapEntry hasName 
		ifTrue: [ (self entriesAt: aPlatform) at: aKeymapEntry name put: aKeymapEntry].! !

!KMCategory methodsFor: 'associating' stamp: 'GuillermoPolito 10/21/2011 00:40'!
allEntries
	^self commonEntries, self platformEntries! !

!KMCategory methodsFor: 'accessing' stamp: 'CamilloBruni 3/18/2011 23:11'!
categoryName
	^ name! !

!KMCategory methodsFor: 'associating' stamp: 'GuillermoPolito 10/21/2011 00:23'!
commonEntries
	^self entriesAt: #all! !

!KMCategory methodsFor: 'accessing' stamp: 'GuillermoPolito 10/21/2011 00:20'!
entriesAt: aPlatform
	platforms ifNil: [ platforms := Dictionary new ].
	^platforms at: aPlatform ifAbsentPut: [ Dictionary new ].! !

!KMCategory methodsFor: 'associating' stamp: 'GuillermoPolito 10/21/2011 00:33'!
hasKeymapNamed: aKeymapEntryName
	^self allEntries includesKey: aKeymapEntryName! !

!KMCategory methodsFor: 'associating' stamp: 'GuillermoPolito 10/21/2011 00:18'!
hasKeymapNamed: aKeymapEntryName at: aPlatform
	^ (self entriesAt: aPlatform) includesKey: aKeymapEntryName! !

!KMCategory methodsFor: 'associating' stamp: 'GuillermoPolito 11/6/2011 10:24'!
keymapNamed: aKeymapEntryName
	^self keymapNamed: aKeymapEntryName inKeymaps: (self allEntries)! !

!KMCategory methodsFor: 'associating' stamp: 'GuillermoPolito 11/6/2011 10:23'!
keymapNamed: aKeymapEntryName at: aPlatform
	^ self keymapNamed: aKeymapEntryName inKeymaps: (self entriesAt: aPlatform)! !

!KMCategory methodsFor: 'associating' stamp: 'GuillermoPolito 11/6/2011 10:23'!
keymapNamed: aKeymapEntryName inKeymaps: someKeymapsDictionary
	^someKeymapsDictionary
		at: aKeymapEntryName
		ifAbsent: [ KMKeymap 
				named: aKeymapEntryName
				shortcut: KMNoShortcut new
				action: [ "Do Nothing" ]]! !

!KMCategory methodsFor: 'accessing' stamp: 'GuillermoPolito 10/21/2011 00:38'!
keymaps
	^self allEntries values! !

!KMCategory methodsFor: 'testing' stamp: 'GuillermoPolito 10/21/2011 00:37'!
matches: aString
	^ self keymaps anySatisfy: [ :entry | 
		entry matches: aString ]! !

!KMCategory methodsFor: 'testing' stamp: 'GuillermoPolito 10/21/2011 00:37'!
matchesCompletely: aString
	^ self keymaps anySatisfy: [ :entry | 
		entry matchesCompletely: aString ]! !

!KMCategory methodsFor: 'accessing' stamp: 'CamilloBruni 3/18/2011 23:11'!
name
	^ name! !

!KMCategory methodsFor: 'accessing' stamp: 'GuillermoPolito 12/14/2010 00:58'!
name: aCategorySymbol 
	name := aCategorySymbol ! !

!KMCategory methodsFor: 'matching' stamp: 'GuillermoPolito 10/20/2011 15:55'!
onMatchWith: anEventBuffer notify: aMatchListener andDo: aBlock
	self keymaps do: [ :entry | 
		entry onMatchWith: anEventBuffer 
			notify: aMatchListener 
			andDo: aBlock ].! !

!KMCategory methodsFor: 'associating' stamp: 'GuillermoPolito 10/21/2011 00:50'!
platformEntries
	^self entriesAt: Smalltalk os current platformFamily! !

Object subclass: #KMCategoryTarget
	instanceVariableNames: 'target category morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Core'!

!KMCategoryTarget class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 10/20/2011 19:05'!
target: aTarget morph: aMorph category: aCategory
	^self new
		target: aTarget;
		category: aCategory;
		morph: aMorph;
		yourself! !

!KMCategoryTarget methodsFor: 'accessing' stamp: 'GuillermoPolito 10/20/2011 18:37'!
category: aCategory
	category := aCategory! !

!KMCategoryTarget methodsFor: 'matching' stamp: 'GuillermoPolito 10/21/2011 09:31'!
completeMatch: aKeymap buffer: aBuffer
	aKeymap action cull: target value cull: morph cull: aBuffer first! !

!KMCategoryTarget methodsFor: 'accessing' stamp: 'GuillermoPolito 10/20/2011 19:05'!
morph: aMorph
	morph := aMorph! !

!KMCategoryTarget methodsFor: 'matching' stamp: 'GuillermoPolito 10/20/2011 18:53'!
noMatch
	"do nothing"
	! !

!KMCategoryTarget methodsFor: 'matching' stamp: 'GuillermoPolito 10/20/2011 18:53'!
partialMatch
	"do nothing"
	! !

!KMCategoryTarget methodsFor: 'accessing' stamp: 'GuillermoPolito 10/20/2011 18:37'!
target: aTarget
	target := aTarget! !

!KMCategoryTarget methodsFor: 'matching' stamp: 'GuillermoPolito 11/2/2011 21:54'!
verifyMatchWith: anEventBuffer notifying: aListener thenDoing: anAction
	self flag: #fixme. "ugly hack with array of listeners"
	category onMatchWith:  anEventBuffer
			notify: { aListener . self } " first we have to tell the dispatcher "
			andDo: anAction! !

Object subclass: #KMDispatcher
	instanceVariableNames: 'target buffer shortcut currentEvent targets morph directKeymaps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Core'!

!KMDispatcher commentStamp: 'GuillermoPolito 12/24/2010 19:00' prior: 0!
I'm an object that saves a buffer of keyevents for the morph I'm attached.
I am the one that dispatches the single and multiple shortcuts.
If the morph has a keymap that matches the keyboard event, I tell the keymap event to execute with the morph I'm attached.!

!KMDispatcher class methodsFor: 'instance creation' stamp: 'GuillermoPolito 5/30/2011 01:26'!
target: aTarget
	^ self target: #yourself morph: aTarget! !

!KMDispatcher class methodsFor: 'instance creation' stamp: 'GuillermoPolito 5/31/2011 11:02'!
target: aTargetSelector morph: aMorph
	^ (self new)
		target: (KMTarget for: aTargetSelector in: aMorph);
		yourself! !

!KMDispatcher methodsFor: 'building' stamp: 'GuillermoPolito 10/20/2011 19:20'!
attachCategory: aCategoryName
	self attachCategory: aCategoryName targetting: morph! !

!KMDispatcher methodsFor: 'building' stamp: 'GuillermoPolito 10/20/2011 23:35'!
attachCategory: aCategoryName onProperty: aProperty
	self targets add: (KMCategoryTarget 
						target: [ morph perform: aProperty ] 
						morph: morph 
						category: (KMRepository default categoryForName: aCategoryName) )! !

!KMDispatcher methodsFor: 'building' stamp: 'GuillermoPolito 10/20/2011 19:20'!
attachCategory: aCategoryName targetting: anObject
	self targets add: (KMCategoryTarget target: anObject morph: morph category: (KMRepository default categoryForName: aCategoryName) )! !

!KMDispatcher methodsFor: 'match' stamp: 'CamilloBruni 3/19/2011 19:55'!
buffer
	^ buffer	! !

!KMDispatcher methodsFor: 'initialize' stamp: 'GuillermoPolito 4/10/2011 01:06'!
clearBuffer
	buffer := OrderedCollection new.
	shortcut := KMNoShortcut new.! !

!KMDispatcher methodsFor: 'match' stamp: 'GuillermoPolito 11/1/2011 17:52'!
completeMatch: aKeymapEntry buffer: aBuffer
	KMLog log: 'Complete match: ', aKeymapEntry printString.
	self clearBuffer.
	currentEvent wasHandled: true.! !

!KMDispatcher methodsFor: 'dispatching' stamp: 'GuillermoPolito 10/20/2011 19:27'!
directKeymaps
	^directKeymaps ifNil: [ directKeymaps := KMCategory new ]! !

!KMDispatcher methodsFor: 'dispatching' stamp: 'GuillermoPolito 10/20/2011 18:38'!
dispatch: anEventBuffer
	| association match |
	self keymapObservers do: [ :aTarget | 
		"nice hack to stop in the first listener"
		aTarget verifyMatchWith: anEventBuffer 
			notifying: self
			thenDoing: [ ^self ] ].
	self noMatch! !

!KMDispatcher methodsFor: 'dispatching' stamp: 'GuillermoPolito 11/6/2011 10:27'!
dispatchKeystroke: aKeyEvent
	KMLog log: aKeyEvent printString, String cr.
	self matchEvent: aKeyEvent.
	aKeyEvent wasHandled
		ifTrue: [ 
			self target clearOwnerBuffers.
			^ self ].
	self target dispatchOwnerKeystroke: aKeyEvent.! !

!KMDispatcher methodsFor: 'initialize' stamp: 'GuillermoPolito 3/14/2011 02:21'!
initialize
	super initialize.
	self clearBuffer.! !

!KMDispatcher methodsFor: 'dispatching' stamp: 'GuillermoPolito 10/20/2011 19:30'!
keymapObservers
	^self targets, self staticTargets, { self perInstanceTarget }! !

!KMDispatcher methodsFor: 'match' stamp: 'GuillermoPolito 10/20/2011 18:55'!
matchEvent: keyboardEvent
	
	self buffer add: keyboardEvent.
	currentEvent := keyboardEvent.

	self dispatch: self buffer.! !

!KMDispatcher methodsFor: 'match' stamp: 'DeboraFortini 10/18/2011 19:20'!
noMatch
	self clearBuffer.! !

!KMDispatcher methodsFor: 'building' stamp: 'GuillermoPolito 10/20/2011 19:30'!
on: aShortcut do: anAction
	self directKeymaps 
		addKeymapEntry: (KMKeymap 
			named: #changeThisPlease
			shortcut: aShortcut 
			action: anAction)! !

!KMDispatcher methodsFor: 'match' stamp: 'GuillermoPolito 11/2/2011 21:55'!
partialMatch
	KMLog log: 'Complete match: ', currentEvent printString.
	currentEvent wasHandled: true.! !

!KMDispatcher methodsFor: 'dispatching' stamp: 'GuillermoPolito 10/20/2011 19:30'!
perInstanceTarget
	^KMCategoryTarget target: morph morph: morph category: self directKeymaps.! !

!KMDispatcher methodsFor: 'dispatching' stamp: 'GuillermoPolito 11/2/2011 22:18'!
staticTargets
	self flag: #deprecated. "static targets should not be used any more"

	^(KMRepository default categoriesForClass: target realTarget class) 
		collect: [ :cat | KMCategoryTarget 
						target: target realTarget 
						morph: target morph 
						category: cat ].! !

!KMDispatcher methodsFor: 'accessing' stamp: 'CamilloBruni 3/18/2011 23:11'!
target
	^ target! !

!KMDispatcher methodsFor: 'accessing' stamp: 'GuillermoPolito 10/20/2011 19:16'!
target: aTarget
	target := aTarget.
	morph := target morph.
	self clearBuffer! !

!KMDispatcher methodsFor: 'dispatching' stamp: 'GuillermoPolito 10/20/2011 18:20'!
targets
	^targets ifNil: [ targets := Set new ]! !

!KMDispatcher methodsFor: 'initialize' stamp: 'GuillermoPolito 5/31/2011 11:19'!
wasNotified
	 ^currentEvent wasHandled! !

Object subclass: #KMFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Core'!

!KMFactory commentStamp: 'GuillermoPolito 2/24/2011 23:43' prior: 0!
I am a class used to access some of the main classes of Keymapping. See my class side to have an idea of what can I give you.!

!KMFactory class methodsFor: 'accessing' stamp: 'CamilloBruni 3/18/2011 23:11'!
keymapContainer
	^ KMRepository default! !

Object subclass: #KMKeymap
	instanceVariableNames: 'action name shortcut defaultShortcut description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Core'!

!KMKeymap commentStamp: 'GuillermoPolito 12/14/2010 21:33' prior: 0!
I am the real keymap.  I have an action to evaluate when my keymap sequence is pressed.!

!KMKeymap class methodsFor: 'instance creation' stamp: 'GuillermoPolito 10/18/2011 20:49'!
named: keymapName shortcut: aShortcut action: anAction
	^ (self new)
		name: keymapName;
		defaultShortcut: aShortcut;
		shortcut: aShortcut;
		action: anAction;
		yourself! !

!KMKeymap class methodsFor: 'instance creation' stamp: 'GuillermoPolito 4/6/2012 13:27'!
named: keymapName shortcut: aShortcut action: anAction description: aDescription
	^ (self new)
		name: keymapName;
		defaultShortcut: aShortcut;
		shortcut: aShortcut;
		action: anAction;
		description: aDescription;
		yourself! !

!KMKeymap methodsFor: 'comparing' stamp: 'GuillermoPolito 9/12/2011 17:47'!
= aKeymap
	^action = aKeymap action and: [ shortcut = aKeymap shortcut and: [ name = aKeymap name ] ]! !

!KMKeymap methodsFor: 'accessing' stamp: 'CamilloBruni 3/18/2011 23:11'!
action
	^ action! !

!KMKeymap methodsFor: 'accessing' stamp: 'CamilloBruni 3/18/2011 23:35'!
action: anAction
	action := anAction! !

!KMKeymap methodsFor: 'accessing' stamp: 'GuillermoPolito 10/18/2011 20:49'!
defaultShortcut
	^defaultShortcut! !

!KMKeymap methodsFor: 'accessing' stamp: 'GuillermoPolito 10/18/2011 20:49'!
defaultShortcut: aShortcut
	defaultShortcut := aShortcut.! !

!KMKeymap methodsFor: 'accessing' stamp: 'GuillermoPolito 4/6/2012 13:28'!
description
	^description ifNil: [ '' ]! !

!KMKeymap methodsFor: 'accessing' stamp: 'GuillermoPolito 4/6/2012 13:28'!
description: aDescription
	description := aDescription asString! !

!KMKeymap methodsFor: 'executing' stamp: 'GuillermoPolito 10/20/2011 18:58'!
executeActionTargetting: target
	^ self action cull: target cull: target! !

!KMKeymap methodsFor: 'accessing' stamp: 'GuillermoPolito 9/12/2011 17:32'!
hasName
	^name notNil! !

!KMKeymap methodsFor: 'comparing' stamp: 'GuillermoPolito 9/12/2011 17:49'!
hash
	^action hash bitXor: (shortcut hash bitXor: name hash)! !

!KMKeymap methodsFor: 'accessing' stamp: 'CamilloBruni 3/18/2011 23:11'!
key
	^ name! !

!KMKeymap methodsFor: 'matching' stamp: 'GuillermoPolito 10/20/2011 16:45'!
matches: anEventBuffer
	^ self shortcut matches: anEventBuffer! !

!KMKeymap methodsFor: 'matching' stamp: 'GuillermoPolito 11/2/2011 22:33'!
matchesCompletely: aShortcut
	^ self shortcut = aShortcut asShortcut! !

!KMKeymap methodsFor: 'accessing' stamp: 'CamilloBruni 3/18/2011 23:11'!
name
	^ name! !

!KMKeymap methodsFor: 'accessing' stamp: 'GuillermoPolito 12/26/2010 22:14'!
name: aName
	name := aName! !

!KMKeymap methodsFor: 'matching' stamp: 'GuillermoPolito 10/20/2011 19:11'!
notifyCompleteMatchTo: aListener buffer: aBuffer
	| listeners |
	aListener isCollection ifTrue: [ listeners := aListener ] ifFalse: [ listeners := { aListener } ].
	listeners do: [ :l | l completeMatch: self buffer: aBuffer ].! !

!KMKeymap methodsFor: 'matching' stamp: 'GuillermoPolito 10/20/2011 18:56'!
notifyPartialMatchTo: aListener
	| listeners |
	aListener isCollection ifTrue: [ listeners := aListener ] ifFalse: [ { aListener } ].
	listeners do: [ :l | l partialMatch ].! !

!KMKeymap methodsFor: 'matching' stamp: 'GuillermoPolito 10/20/2011 19:11'!
onMatchWith: anEventBuffer notify: aMatchListener andDo: anAction
	(self matches: anEventBuffer)
			ifTrue: [ 
				(self matchesCompletely: anEventBuffer)
					ifTrue: [ self notifyCompleteMatchTo: aMatchListener buffer: anEventBuffer ]
					ifFalse: [ self notifyPartialMatchTo: aMatchListener ].
					anAction value.
				] ! !

!KMKeymap methodsFor: 'accessing' stamp: 'GuillermoPolito 5/31/2011 12:50'!
printOn: aStream
	aStream 
		nextPutAll: self name printString;
		nextPutAll: ' on ';
		nextPutAll: self shortcut printString;
		nextPutAll: ' do ' ;
		nextPutAll: self action printString;
		cr.    ! !

!KMKeymap methodsFor: 'accessing' stamp: 'CamilloBruni 3/18/2011 23:11'!
shortcut
	^ shortcut! !

!KMKeymap methodsFor: 'accessing' stamp: 'GuillermoPolito 3/14/2011 02:54'!
shortcut: aShortcut
	shortcut := aShortcut.! !

!KMKeymap methodsFor: 'accessing' stamp: 'GuillermoPolito 11/6/2011 10:17'!
shortcutHasChangedBy: aShortcut
	self defaultShortcut = self shortcut ifTrue: [ self shortcut: aShortcut ].
	self defaultShortcut: aShortcut! !

Object subclass: #KMLog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Core'!

KMLog class
	instanceVariableNames: 'debug'!

KMLog class
	instanceVariableNames: 'debug'!

!KMLog class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/1/2011 17:50'!
log: aMessage
	(debug notNil and: [ debug ]) ifTrue: [ Transcript show: aMessage ]! !

!KMLog class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/1/2011 17:51'!
removeDebug
	debug := false! !

!KMLog class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/1/2011 17:51'!
setDebug
	debug := true! !

Object subclass: #KMNoKeymap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Core'!

!KMNoKeymap commentStamp: 'GuillermoPolito 2/24/2011 23:43' prior: 0!
I am a Null object representing the absence of a Keymap.!

!KMNoKeymap methodsFor: 'accessing' stamp: 'CamilloBruni 3/18/2011 23:11'!
shortcut
	^ KMNoShortcut new! !

Object subclass: #KMRepository
	instanceVariableNames: 'categories categoryHolders'
	classVariableNames: 'Singleton'
	poolDictionaries: ''
	category: 'Keymapping-Core'!

!KMRepository commentStamp: 'GuillermoPolito 12/14/2010 21:37' prior: 0!
I have a singleton instance which can be accessed by executing the following:
"self default"

I am currently a god object to be refactored =D.!

!KMRepository class methodsFor: 'instance creation' stamp: 'CamilloBruni 3/18/2011 23:11'!
default
	^ Singleton ifNil: [ Singleton := self new ]! !

!KMRepository class methodsFor: 'instance creation' stamp: 'CamilloBruni 3/18/2011 23:11'!
default: aDefault
	^ Singleton := aDefault! !

!KMRepository class methodsFor: 'instance creation' stamp: 'DeboraFortini 10/18/2011 20:31'!
reset
	self default: self new.
	KMPragmaKeymapBuilder uniqueInstance reset.! !

!KMRepository methodsFor: 'associating' stamp: 'GuillermoPolito 12/15/2010 01:59'!
addCategory: aCategory
	(self includesCategory: aCategory)
		ifTrue: [ self error: 'a Category named ' , aCategory name, ' already exists.' ].
	self categories at: aCategory name put: aCategory.! !

!KMRepository methodsFor: 'keymaps' stamp: 'GuillermoPolito 12/26/2010 22:05'!
attach: aCategory to: aClass
	(self categoryHolders includesKey: aClass) 
		ifFalse: [ self categoryHolders at: aClass put: Set new ].
	
	(self categoryHolders at: aClass) add: aCategory! !

!KMRepository methodsFor: 'keymaps' stamp: 'GuillermoPolito 3/13/2011 17:58'!
attachCategoryName: aCategorySymbol to: aClass 
	self attach: (self ensureCategoryByName: aCategorySymbol) to: aClass.! !

!KMRepository methodsFor: 'accessing' stamp: 'CamilloBruni 3/18/2011 23:11'!
categories
	^ categories ifNil: [ categories := Dictionary new ]! !

!KMRepository methodsFor: 'accessing' stamp: 'GuillermoPolito 11/2/2011 22:14'!
categoriesForClass: aClass
	| classCategories superclassCategories |
	aClass == Object
		ifTrue: [ ^ Set new ].
	classCategories := self categoryHolders at: aClass ifAbsent: [ Set new ].
	superclassCategories := self categoriesForClass: aClass superclass.
	^ classCategories union: superclassCategories! !

!KMRepository methodsFor: 'accessing' stamp: 'GuillermoPolito 5/31/2011 11:26'!
categoryForName: aCategorySymbol
	^ self categories at: aCategorySymbol ifAbsentPut: [ KMCategory named: aCategorySymbol ]! !

!KMRepository methodsFor: 'accessing' stamp: 'CamilloBruni 3/18/2011 23:11'!
categoryHolders
	^ categoryHolders ifNil: [ categoryHolders := Dictionary new ]! !

!KMRepository methodsFor: 'accessing' stamp: 'CamilloBruni 3/18/2011 23:11'!
ensureCategoryByName: aCategorySymbol
	| category |
	(self includesCategoryNamed: aCategorySymbol)
		ifFalse: [ 
			category := KMCategory named: aCategorySymbol.
			self addCategory: category ]
		ifTrue: [ category := self categoryForName: aCategorySymbol ].
	^ category! !

!KMRepository methodsFor: 'testing' stamp: 'CamilloBruni 3/18/2011 23:11'!
includesCategory: aCategory
	^ self categories includes: aCategory! !

!KMRepository methodsFor: 'testing' stamp: 'CamilloBruni 3/18/2011 23:11'!
includesCategoryNamed: aCategorySymbol
	^ self categories includesKey: aCategorySymbol! !

!KMRepository methodsFor: 'accessing' stamp: 'GuillermoPolito 4/6/2012 13:25'!
initializeKeymap: shortcutName executingOn: shortcut doing: action inCategory: categoryName platform: aPlatform
	^self initializeKeymap: shortcutName executingOn: shortcut doing: action inCategory: categoryName platform: aPlatform description: ''! !

!KMRepository methodsFor: 'accessing' stamp: 'GuillermoPolito 4/6/2012 13:25'!
initializeKeymap: shortcutName executingOn: shortcut doing: action inCategory: categoryName platform: aPlatform description: aDescription
	| category entry |
	category := self ensureCategoryByName: categoryName.
	(category hasKeymapNamed: shortcutName at: aPlatform) not
		ifTrue: [
			entry := shortcut asShortcut named: shortcutName do: action withDescription: aDescription.
			category addKeymapEntry: entry at: aPlatform.
			]
		ifFalse:[
			entry := category keymapNamed: shortcutName at: aPlatform.
			entry shortcutHasChangedBy: shortcut asShortcut.
			entry action: action.
			entry description: aDescription
			]! !

!KMRepository methodsFor: 'accessing' stamp: 'CamilloBruni 3/18/2011 23:11'!
keymapNamed: aKeymapName inCategory: aKeymapCategory
	^ (self categoryForName: aKeymapCategory) keymapNamed: aKeymapName! !

Object subclass: #KMTarget
	instanceVariableNames: 'realTarget morph targetSelector directKeymaps perInstanceCategories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Core'!

!KMTarget commentStamp: 'GuillermoPolito 2/24/2011 23:44' prior: 0!
I am the reification of the Keymap target.  I am the one that receives the actions.!

!KMTarget class methodsFor: 'instance creation' stamp: 'GuillermoPolito 5/31/2011 11:11'!
for: aTarget in: aMorph
	^ (self new)
		targetSelector: aTarget;
		morph: aMorph;
		yourself! !

!KMTarget methodsFor: 'accessing' stamp: 'GuillermoPolito 10/20/2011 17:30'!
clearOwnerBuffers
	morph ownerChain asSet
		remove: morph; 
		do: [ :o | o kmDispatcher clearBuffer ].! !

!KMTarget methodsFor: 'accessing' stamp: 'GuillermoPolito 5/31/2011 11:04'!
dispatchOwnerKeystroke: aKeyEvent
	morph owner 
		ifNil: [ ^ self ].
	morph owner dispatchKeystrokeForEvent: aKeyEvent! !

!KMTarget methodsFor: 'accessing' stamp: 'GuillermoPolito 10/20/2011 19:07'!
morph
	^morph! !

!KMTarget methodsFor: 'accessing' stamp: 'GuillermoPolito 5/29/2011 23:50'!
morph: aMorph
	morph := aMorph! !

!KMTarget methodsFor: 'accessing' stamp: 'GuillermoPolito 5/31/2011 11:15'!
realTarget
	^morph perform: self targetSelector! !

!KMTarget methodsFor: 'accessing' stamp: 'GuillermoPolito 5/31/2011 11:18'!
targetSelector
	^targetSelector ifNil: [ #yourself ]! !

!KMTarget methodsFor: 'accessing' stamp: 'GuillermoPolito 5/31/2011 11:10'!
targetSelector: aTargetSelector
	targetSelector := aTargetSelector! !
